#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		char Msg[58]="AFKLISTBOT: ";
		Msg[57]=0;//issure that a null gets placed
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
				strncat(Msg,"!ignorelist !addignore !removeignore ",37);
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				strncat(Msg,"!afklist",8);
			}
		}
		sendPrivate(p,Msg);
		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if(c->checkParam("ignorelist"))
			{
				sendPrivate(p,"Command !ignorelist: Displays the list of players who will not be listed on the !afklist");
			}
			else if(c->checkParam("addignore"))
			{
				sendPrivate(p,"Command !addignore <PlayerName>: Adds a player to the afk-ignore list, such as bots and other players who will not be considered afk");
			}
			else if(c->checkParam("removeignore"))
			{
				sendPrivate(p,"Command !removeignore <PlayerName>: Removes a player from the afk-ignore list");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(c->checkParam("afklist"))
			{
				sendPrivate(p,"Command !afklist: This command will display a list of players that are in spec and the time they last sent a text message.");
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if(c->check("ignorelist"))
			{
				sendPrivate(p,"AFK Ignore-List");
				sendPrivate(p,"---------------");
				for(_listnode <Ignore> *il=IgnoreList.head;il;il=il->next)
				{	
					sendPrivate(p,il->item->name);
				}
			}
			else if(c->check("addignore"))
			{
				String Message;
				if(c->final[0])
				{
					if(STRLEN(c->final) < 20)
					{
						for(_listnode <Ignore> *il=IgnoreList.head;il;il=il->next)
						{
							if(CMPSTR(il->item->name,c->final))
							{break;}
						}

						if(il==NULL)
						{
							if(IgnoreList.total <= 50)
							{
								for(_listnode <AfkTime> *al=AfkList.head;al;al=al->next)
								{
									if(CMPSTR(al->item->name,c->final))
									{
										AfkList.kill(al);
										break;
									}
								}
								Ignore *newIgnore=new Ignore;
								memcpy(newIgnore->name,c->final,20);
								IgnoreList.append(newIgnore);
								SaveIgnores();
								Message="Player successfully added to the afk ignore list!";
							}
							else
							{Message="You may only have a max of 50 people on the afk ignore list :(";}
						}
						else
						{Message="That player is already on the afk ignore list!";}
					}
					else
					{Message="Player names are less than 20 characters long";}
				}
				else
				{Message="You must specify a player name. Ex- !addignore 50% Packetloss";}
				sendPrivate(p,Message);
			}
			else if(c->check("removeignore"))
			{
				String Message;
				if(c->final[0])
				{
					for(_listnode <Ignore> *il=IgnoreList.head;il;il=il->next)
					{
						if(CMPSTR(il->item->name,c->final))
						{
							for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
							{
								if(CMPSTR(pl->item->name,c->final))
								{
									if(pl->item->ship==SHIP_Spectator)
									{
										AfkList.append(new AfkTime(pl->item));
									}
									break;
								}
							}
							IgnoreList.kill(il);
							SaveIgnores();
							Message="Player successfully removed from AFK ignore list!";
							break;
						}
					}
					if(il==NULL)
					{Message="That player was not found on the afk ignore list";}
				}
				else
				{Message="You must specify a player name to be removed from the afk ignore list. Ex- !removeignore Rifleman";}
				sendPrivate(p,Message);
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->check("version"))
			{sendPrivate(p,"[afklist.dll] [AFK-List Bot] [50% Packetloss] [build 2]");}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(c->check("afklist"))
			{
				Uint32 Tick=GetTickCount();
				Uint32 Time,toStr;
				const Uint32 Convert[4]={216000,3600,60,1};
				Uint16 StrLen,i;

				char Lines[38]="|-------------------|---------------|";
				char Msg[38]=  "|50% Packetloss <3  |00d,00h,00m,00s|";
			
				sendPrivate(p,Lines);
				sendPrivate(p,"|Player\'s Name      |Day,Hrs.Min,Sec|");
				sendPrivate(p,Lines);

				for(_listnode <AfkTime> *al=AfkList.head;al;al=al->next)
				{
					if(!CMPSTR(al->item->name,p->name))
					{
						StrLen=1;
						Time=(Tick-al->item->Time)/1000;//seconds
					
						for(i=0;i<19;i++)
						{
							if(al->item->name[i] != NULL)
							{Msg[StrLen]=al->item->name[i];}
							else
							{break;}

							StrLen++;
						}
						memset(Msg+StrLen,' ',20-StrLen);
						StrLen=21;
						
						for(i=0;i<4;i++)
						{
							toStr=Time/Convert[i];
							Msg[StrLen++]=char((toStr/10) | 0x30);
							Msg[StrLen]=char((toStr%10) | 0x30);

							Time-=toStr*Convert[i];
							StrLen+=3;
						}
						sendPrivate(p,Msg);
					}
				}

				sendPrivate(p,Lines);
			}
			else if (c->check("about"))
			{
				sendPrivate(p, "Afk-List Bot by 50% Packetloss (FiftyPacketloss@socal.rr.com)");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
